import numpy as np
import matplotlib.pyplot as plt
import numba as nb

#@nb.jit(nb.int64(nb.float64, nb.int64, nb.int64[:,:]))
def sweep(beta,L,s):
    
    probs=np.array([np.exp(-4*beta),np.exp(-8*beta)])
    
    dMtot=0

    for i in range(L):
        for j in range(L):
            
            dE=2*s[i,j]*(s[i-1,j]+s[(i+1)%L,j]+s[i,j-1]+s[i,(j+1)%L])

            if dE>0 and probs[dE//4-1]<np.random.random(): continue
            
            s[i,j]=-s[i,j]
            dMtot+=2*s[i,j]

    return dMtot


L=32
s=np.ones((L,L),dtype=int)
M=L**2

NT=100
T=np.linspace(0.04,4,NT)

Navg=50
Msamp=np.zeros((NT,Navg))

for i in range(NT):
    print(i)
    beta=1/T[i]
    
    for j in range(Navg):
        M+=sweep(beta,L,s)
            
    for j in range(Navg):
        M+=sweep(beta,L,s)
        Msamp[i,j]=M/L**2

    Mavg=np.average(Msamp,axis=1)

plt.plot(T,Mavg)
plt.show()
